#ifndef GEOSPHERE_H
#define GEOSPHERE_H

/*
 *  geosphere.h
 *  openb3d
 *
 *
 */

#include "terrain.h" //  "shadermat.h"

class Geosphere : public Terrain{
  private:
	float dradius;
	float* NormalsMap;
	float xcf,ycf,zcf; 			//used to store camera position

	void TOASTsub(int l, float v0[], float v1[], float v2[]);
	void geosub(int l, float v0[], float v1[], float v2[]);
	void c_col_tree_geosub(int l, float v0[], float v1[], float v2[]);

	void EquirectangularToTOAST();

  public:
	float hsize;

	static Geosphere* CreateGeosphere(int tsize=0, Entity* parent_ent=NULL);
	static Geosphere* LoadGeosphere(string filename,Entity* parent_ent=NULL);
	Geosphere* CopyEntity(Entity* parent_ent=NULL);
	void FreeEntity(void);

	void UpdateTerrain();
	void RecreateGeoROAM();
	void UpdateNormals(int preserve=0);

	void ModifyGeosphere (int x, int y, float new_height);
	void TreeCheck(CollisionInfo* ci);
	// !!! added
 	void SetUserdata(void* ud);
  void* GetUserdata(void);
  protected:
  void* userdata;
};

#endif
