#ifndef SPRITE_H
#define SPRITE_H

/*
 *  sprite.h
 *  iminib3d
 *
 *  Created by Simon Harrison.
 *  Copyright Si Design. All rights reserved.
 *
 */

#include "mesh.h"

#include <iostream>
using namespace std;

class Sprite : public Mesh{
  public:

	float angle;
	float scale_x,scale_y;
	float handle_x,handle_y;
	int   view_mode;
	int   render_mode;

	Sprite* CopyEntity(Entity* parent_ent=NULL);
	static Sprite* CreateSprite(Entity* parent_ent=NULL);
	static Sprite* LoadSprite(string tex_file,int tex_flag=1,Entity* parent_ent=NULL);

	void RotateSprite(float ang);
	void ScaleSprite(float s_x,float s_y);
	void HandleSprite(float h_x,float h_y);
	void SpriteViewMode(int mode);
	void SpriteRenderMode(int mode);
	void SpriteTexCoords(int cell_x,int cell_y,int cell_w,int cell_h,int tex_w,int tex_h,int uv_set=0);
	void SpriteVertexColor(int v,float r,float g,float b);

	Sprite() {
		angle       = 0.0f;
		scale_x     = 1.0f;
		scale_y     = 1.0f;
		handle_x    = 0.0f;
		handle_y    = 0.0f;
		view_mode   = 1; // SPRITE_VIEWMODE_FIXED
		render_mode = 1; // SPRITE_RENDERMODE_CAMERA
	}
	void FreeEntity(void);

	// !!! added
	void  SetUserdata(void* ud);
  void* GetUserdata(void);
  protected:
  void* userdata;
};

#endif
